/* Copyright 2005 Scott Torborg */

/* This code is released under the GNU General Public License. 
 * For more information, see the COPYING file included in this 
 * package. */

/* hsv.c - HSV functions used by diamond.c */

void HSVtoRGBfloat(float *R, float *G, float *B, float H, float S, float V)
{
  float var_h, var_1, var_2, var_3, var_r, var_g, var_b;
  int var_i;

  if ( S == 0 )                       //HSV values = From 0 to 1
    {
      *R = V;
      *G = V;
      *B = V;
    }
  else
    {
      var_h = H * 6;
      var_i = (int)( var_h );             //Or ... var_i = dancefloor( var_h )
      var_1 = V * ( 1.0 - S );
      var_2 = V * ( 1.0 - S * ( var_h - var_i ) );
      var_3 = V * ( 1.0 - S * ( 1 - ( var_h - var_i ) ) );

      if      ( var_i == 0 ) { var_r = V     ; var_g = var_3 ; var_b = var_1; }
      else if ( var_i == 1 ) { var_r = var_2 ; var_g = V     ; var_b = var_1; }
      else if ( var_i == 2 ) { var_r = var_1 ; var_g = V     ; var_b = var_3; }
      else if ( var_i == 3 ) { var_r = var_1 ; var_g = var_2 ; var_b = V; }
      else if ( var_i == 4 ) { var_r = var_3 ; var_g = var_1 ; var_b = V; }
      else { var_r = V     ; var_g = var_1 ; var_b = var_2; }
      
      *R = var_r;
      *G = var_g;
      *B = var_b;
    }

}

void hsvrgb(char *r, char *g, char *b, float h, float s, float v)
{
  float rf, gf, bf;
  HSVtoRGBfloat(&rf, &gf, &bf, h, s, v);
  *r = (char)(rf*255);
  *g = (char)(gf*255);
  *b = (char)(bf*255);
  //printf("%f %f %f\n", rf, gf, bf);
}
