/* Copyright 2005 Scott Torborg */

/* This code is released under the GNU General Public License. 
 * For more information, see the COPYING file included in this 
 * package. */

/* DISCO DANCE FLOOR XMMS SPECTRUM DISPLAY
 * First East, MIT
 * March 2005 */

#include <xmms/plugin.h>
#include "spectrum.h"
#include "ddf.h"

/* take shared frequency data and render floor */
void
render_spectrum(gint16 (*shared_freq_data)[256], unsigned char* floor_data)
{
	int x, y, i, j;
	gint16 temp;
	unsigned char r, g, b;
	/* look at every 8th band and scale magnitude
	 * to 0:16 range */		
	
	/* iterate through columns */
	for(y = 0; y < COLS; y++) {
		/* this goes in the short direction */
		for(x = 0; x < ROWS; x++) {
			/* this goes in the long direction */

			/* get the address for x, y */
			i = (COLS*x + y) * 3;
			/* reset colors */
			r = 0; g = 0; b = 0;
			
			temp=0;
			for (j=0;j<7;j++)
                temp+=shared_freq_data[0][x*8+j];
			
			/* first the right channel */
			if(y<8 && y > 8-(temp)/512) {
				/* we are inside the magnitude for this
				 * band, turn on the some colors */
				
				r = ((7-y)*36);
				g = (y*36);
			}

			temp=0;
			for (j=0;j<7;j++)
                temp+=shared_freq_data[1][x*8+j];

			/* now do the left channel */
			if(y>=8 && y < 7+(temp)/512) {
				/* we are inside the magnitude for this
				 * band, turn on the some colors */
				
				b = ((y-8)*36);
				g = ((15-y)*36);
			}
			/* copy */
			floor_data[i] = r;
			floor_data[i+1] = g;
			floor_data[i+2] = b;
		}
	}
}