/* Copyright 2005 Grant Elliott */

/* This code is released under the GNU General Public License. 
 * For more information, see the COPYING file included in this 
 * package. */

/* DISCO DANCE FLOOR XMMS VISUALIZATION
 * First East, MIT
 * April 2005 */
 
#include <xmms/plugin.h>
#include "vis.h"
#include "ddf.h"

/* take shared frequency data and render floor */
void
render_vis(gint16 (*shared_freq_data)[256], unsigned char* floor_data)
{
    int mode=1;

	int x, y, i, j;
	long ltot=0,rtot=0,l=0,m=0,h=0;
	float mask,rt,bt,gt;
	unsigned char r, g, b;

	for (i=0;i<20;i++)
	{
	   ltot+=shared_freq_data[0][i];
	   rtot+=shared_freq_data[1][i];
	   l+=shared_freq_data[0][i]+shared_freq_data[1][i];
    }
	for (i=20;i<80;i++)
	{
	   ltot+=shared_freq_data[0][i];
	   rtot+=shared_freq_data[1][i];
	   m+=shared_freq_data[0][i]+shared_freq_data[1][i];
    }
	for (i=80;i<128;i++)
	{
	   ltot+=shared_freq_data[0][i];
	   rtot+=shared_freq_data[1][i];
	   h+=shared_freq_data[0][i]+shared_freq_data[1][i];
    }

	switch(mode)
	{
		case 1:
        for(y = 0; y < COLS; y++) {
        /* this goes in the short direction */
            for(x = 0; x < ROWS; x++) {
                /* this goes in the long direction */

                /* get the address for x, y */
                i = (COLS*x + y) * 3;
                /* reset colors */
                r = 0; g = 0; b = 0;

                if ((ltot+rtot)==0)
                {
                    rt=0;
                    gt=0;
                    bt=0;
                } else {
                    rt=256*(((float) l)/((float) (ltot+rtot)));
                    gt=256*(((float) m)/((float) (ltot+rtot)));
                    bt=256*(((float) h)/((float) (ltot+rtot)));           
                }

                mask=(sin(sqrt((((float) y)-7.5)*(((float) y)-7.5)+
                    (((float) x)-15.5)*(((float) x)-15.5))*(float)(rtot+ltot)/100000));			                
                mask*=mask;

                r=rt*mask;
		      	g=gt*mask;
                b=bt*mask;   

    			/* copy */
    			floor_data[i] = r;
    			floor_data[i+1] = g;
    			floor_data[i+2] = b;
    		}
    	}
        break;
        case 2:
        for(y = 0; y < COLS; y++) {
        /* this goes in the short direction */
            for(x = 0; x < ROWS; x++) {
                /* this goes in the long direction */                
                
            }
        }
	}
}